﻿Public Class Filter_IIR

    Private RegX1() As Double
    Private RegX2() As Double
    Private RegY1() As Double
    Private RegY2() As Double

    Friend a0() As Double
    Friend a1() As Double
    Friend a2() As Double
    Friend b0() As Double
    Friend b1() As Double
    Friend b2() As Double

    Dim NumSections As Int32  ' The number of biquad sections. e.g. PoleCount/2 

    Friend Sub Init(ByVal CoeffsA0() As Double, _
                    ByVal CoeffsA1() As Double, _
                    ByVal CoeffsA2() As Double, _
                    ByVal CoeffsB0() As Double, _
                    ByVal CoeffsB1() As Double, _
                    ByVal CoeffsB2() As Double)
        '
        Debug.Assert(CoeffsA0.Length = CoeffsA1.Length, "Coeff size error")
        Debug.Assert(CoeffsA0.Length = CoeffsA2.Length, "Coeff size error")
        Debug.Assert(CoeffsA0.Length = CoeffsB0.Length, "Coeff size error")
        Debug.Assert(CoeffsA0.Length = CoeffsB1.Length, "Coeff size error")
        Debug.Assert(CoeffsA0.Length = CoeffsB2.Length, "Coeff size error")
        '
        a0 = CoeffsA0
        a1 = CoeffsA1
        a2 = CoeffsA2
        b0 = CoeffsB0
        b1 = CoeffsB1
        b2 = CoeffsB2
        '
        NumSections = CoeffsA0.Length
        '
        ReDim RegX1(NumSections - 1)
        ReDim RegX2(NumSections - 1)
        ReDim RegY1(NumSections - 1)
        ReDim RegY2(NumSections - 1)
    End Sub

    Friend Function NewSample_2ndOrderForm1(ByVal value As Double) As Double
        Dim k As Int32
        Dim y As Double
        y = SectCalcForm1(0, value)
        For k = 1 To NumSections - 1
            y = SectCalcForm1(k, y)
        Next
        Return y
    End Function

    Private Function SectCalcForm1(ByVal k As Int32, ByVal x As Double) As Double
        Dim y As Double
        Dim CenterTap As Double
        CenterTap = x * b0(k) + b1(k) * RegX1(k) + b2(k) * RegX2(k)
        y = CenterTap * a0(k) - a1(k) * RegY1(k) - a2(k) * RegY2(k)
        '
        RegX2(k) = RegX1(k)
        RegX1(k) = x
        RegY2(k) = RegY1(k)
        RegY1(k) = y
        '
        Return y
    End Function

End Class
