﻿Public Class Form1

    Private SlotFilter1 As FilterManager

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        EventsAreEnabled = False
        Me.Text = AppTitleAndVersion()
        Load_INI()
        EventsAreEnabled = True
        Refresh()
        Opacity = 1
        SlotFilter1 = New FilterManager
        SetFilterParams()
        SetFilterCoeffs()
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        EventsAreEnabled = False
        Save_INI()
    End Sub

    Private Sub Form_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Exit Sub
        LimitFormPosition(Me)
    End Sub

    Private Sub SetFilterParams()
        SlotFilter1.SetParams(txt_InputSlot.NumericValueInteger, _
                              txt_OutputSlot.NumericValueInteger, _
                              txt_SampleTimeMS.NumericValueInteger, _
                              txt_Amplitude.NumericValue, _
                              txt_Shift.NumericValue, _
                              chk_InvertFilter.Checked)
    End Sub

    Friend Sub SetFilterCoeffs()
        SlotFilter1.ReadCoefficientFileAndInitFilters()
        Dim type As String = SlotFilter1.GetFilterType
        GroupBox1.Text = "Coefficients file - Type: " + type + " (" + SlotFilter1.GetLenInfo + ")"
        lbl_FileName.Text = IO.Path.GetFileNameWithoutExtension(LastFilePathAndName)
    End Sub


    ' ==============================================================
    '   SET PARAMS - Using TextChanged and CheckedChanged
    ' ==============================================================
    Private ChangedParams As Boolean
    Private Sub txt_TextChanged(ByVal sender As System.Object, _
                                ByVal e As System.EventArgs) _
                                        Handles txt_InputSlot.TextChanged, _
                                                txt_OutputSlot.TextChanged, _
                                                txt_SampleTimeMS.TextChanged, _
                                                txt_Amplitude.TextChanged, _
                                                txt_Shift.TextChanged, _
                                                chk_InvertFilter.CheckedChanged
        If Not EventsAreEnabled Then Exit Sub
        ChangedParams = True
        SetFilterParams()
    End Sub

    ' ==============================================================
    '   SAVE INI - Using MouseLeave
    ' ==============================================================
    Private Sub Params_MouseLeave(ByVal sender As Object, _
                                  ByVal e As System.EventArgs) _
                                        Handles txt_InputSlot.MouseLeave, _
                                                txt_OutputSlot.MouseLeave, _
                                                txt_SampleTimeMS.MouseLeave, _
                                                txt_Amplitude.MouseLeave, _
                                                txt_Shift.MouseLeave, _
                                                chk_InvertFilter.MouseLeave
        If Not EventsAreEnabled Then Return
        If ChangedParams Then
            ChangedParams = False
            Save_INI()
        End If
    End Sub

    ' ==============================================================
    '   LOAD FILE and BROWSE
    ' ==============================================================
    Private Sub lbl_FileName_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lbl_FileName.Click
        LoadFilterDialog()
        lbl_FileName.Focus()
    End Sub
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Browse.Click
        If Not IO.File.Exists(LastFilePathAndName) Or _
                            LastFilePathAndName.StartsWith("\\") Then
            Process.Start(Application.StartupPath + "\Coeffs")
        Else
            Process.Start(IO.Path.GetDirectoryName(LastFilePathAndName))
        End If
    End Sub

End Class
